using System;
using System.Collections.Generic;
using System.Net;
using NUnit.Framework;

namespace Smdn.Net.Imap4.Client {
#if false
  [TestFixture]
  public class ImapClientTests {
    private ImapClient CreateClient()
    {
      return new ImapClient("localhost", 10143, "user");
    }

    private ImapClient Connect()
    {
      var client = CreateClient();

      client.Profile.UseTlsIfAvailable = false;
      client.Connect(credentials);

      Assert.IsTrue(client.IsConnected, "connected");

      return client;
    }

    [SetUp]
    public void SetUp()
    {
      credentials = new NetworkCredential("user", "pass");
    }

    [Test]
    public void TestConnect()
    {
      using (var client = CreateClient()) {
        client.Profile.UseTlsIfAvailable = false;
        client.Connect(credentials);

        Assert.IsTrue(client.IsConnected, "connected");
        Assert.IsNotNull(client.ServerCapabilities, "server capabilities");

        if (client.ServerCapabilities.Has(ImapCapability.ID))
          Assert.IsNotNull(client.ServerID, "server id");
        if (client.ServerCapabilities.Has(ImapCapability.Namespace))
          Assert.IsNotNull(client.ServerNamespace, "server namespace");
      }
    }

    [Test]
    public void TestDisconnect()
    {
      using (var client = Connect()) {
        client.Disconnect();

        Assert.IsFalse(client.IsConnected, "disconnected");

        try {
          client.NoOp();
          Assert.Fail("InvalidOperationException not thrown");
        }
        catch (InvalidOperationException) {
        }

        client.Disconnect();
      }
    }

    [Test]
    public void TestLogout()
    {
      using (var client = Connect()) {
        client.Logout();

        Assert.IsFalse(client.IsConnected, "logged out");

        try {
          client.NoOp();
          Assert.Fail("InvalidOperationException not thrown");
        }
        catch (InvalidOperationException) {
        }

        client.Disconnect();
      }
    }

    [Test]
    public void TestConnectAfterDisconnected()
    {
      using (var client = Connect()) {
        client.Disconnect();

        Assert.IsFalse(client.IsConnected, "logged out");

        client.Connect(credentials);

        Assert.IsTrue(client.IsConnected, "reconnected");

        client.NoOp();
      }
    }

    [Test]
    public void TestNoOp()
    {
      using (var client = Connect()) {
        client.NoOp();
      }
    }

    [Test]
    public void TestGetInbox()
    {
      using (var client = Connect()) {
        var inbox = client.GetInbox();

        Assert.IsNotNull(inbox);
        StringAssert.AreEqualIgnoringCase(inbox.Name, "INBOX");
        Assert.AreEqual(string.Empty, inbox.ParentMailboxName, "parent mailbox name of INBOX");
        /*
        Assert.AreNotEqual(0L, inbox.UidValidity, "uidvalidity");
        Assert.AreNotEqual(0L, inbox.NextUid, "next uid");
        Assert.IsNotNull(inbox.ApplicableFlags, "applicable flags");
        Assert.IsNotNull(inbox.PermanentFlags, "permanent flags");
        Assert.IsNotNull(inbox.Url, "url");
        */
      }
    }

    [Test]
    public void TestGetMailboxes()
    {
      using (var client = Connect()) {
        foreach (var mailbox in client.GetMailboxes()) {
          Assert.IsNotNull(mailbox, "not null");
        }
      }
    }

    [Test]
    public void TestGetMailboxesTopLevelOnly()
    {
      using (var client = Connect()) {
        foreach (var mailbox in client.GetMailboxes(ImapMailboxListOptions.TopLevelOnly)) {
          Assert.IsNotNull(mailbox, "not null");
          Assert.AreEqual(string.Empty, mailbox.ParentMailboxName, "parent mailbox name");
          Assert.IsFalse(mailbox.FullName.Contains(mailbox.MailboxSeparator), "not contains hierarchy delimiter");
        }
      }
    }

    [Test]
    public void TestGetMailboxesSubscribedOnly()
    {
      using (var client = Connect()) {
        foreach (var mailbox in client.GetMailboxes(ImapMailboxListOptions.SubscribedOnly)) {
          Assert.IsNotNull(mailbox, "not null");
        }
      }
    }

    [Test]
    public void TestGetMailboxesRequestStatus()
    {
      using (var client = Connect()) {
        foreach (var mailbox in client.GetMailboxes(ImapMailboxListOptions.RequestStatus)) {
          Assert.IsNotNull(mailbox, "not null");
          Assert.AreNotEqual(0L, mailbox.UidValidity, "uid validity");
          Assert.AreNotEqual(0L, mailbox.NextUid, "next uid");

          if (0L < mailbox.UnseenMessageCount || 0L < mailbox.RecentMessageCount)
            Assert.AreNotEqual(0L, mailbox.ExistMessageCount);
        }
      }
    }

    private ICredentialsByHost credentials;
  }
#endif
}
