using System;
using NUnit.Framework;

namespace Smdn.Net.Imap4 {
  [TestFixture]
  public class ImapMailboxFlagListTests {
    [Test]
    public void TestAsReadOnly()
    {
      var list = new ImapMailboxFlagList(new[] {
        ImapMailboxFlag.NoInferiors,
        ImapMailboxFlag.Subscribed,
      });

      var readOnlyList = list.AsReadOnly();

      Assert.AreNotSame(list, readOnlyList);
      Assert.AreEqual(2, readOnlyList.Count);
      Assert.IsTrue(readOnlyList.Has(ImapMailboxFlag.NoInferiors));
      Assert.IsTrue(readOnlyList.Has("\\Noinferiors"));
      Assert.IsTrue(readOnlyList.Has(ImapMailboxFlag.Subscribed));

      try {
        var collection = readOnlyList as System.Collections.Generic.ICollection<ImapMailboxFlag>;

        collection.Add(ImapMailboxFlag.HasChildren);

        Assert.Fail("NotSupportedException not thrown");
      }
      catch (NotSupportedException) {
      }
    }
  }
}
